//+------------------------------------------------------------------+
//|                                                  CloseCandle.mq4 |
//|                                              Copyright 2016, AM2 |
//|                                      http://www.forexsystems.biz |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, AM2"
#property link      "http://www.forexsystems.biz"
#property version   "1.00"
#property strict
#property indicator_chart_window

input int              FontSize     = 12;                   //  
input string           FontName     = "Arial";              //  
input color            ClrDelta     = Red;                  //   -    
input color            ClrClose     = Yellow;               //   -   
input color            ClrTime      = White;                //   -  
input int              SecondsSound = 20;                   //     
input ENUM_BASE_CORNER Corner       = CORNER_RIGHT_UPPER;   //    
input bool             AlertOn      = false;                //  

bool one=true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   EventSetTimer(1);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   Comment("");
   ObjectDelete(0,"TimeLabel1");
   ObjectDelete(0,"TimeLabel2");
   ObjectDelete(0,"TimeLabel3");
   EventKillTimer();
  }
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
void PutLabel(string name,string text,int x,int y,color clr)
  {
   ObjectDelete(name);
//---   
   ObjectCreate(0,name,OBJ_LABEL,0,0,0);
//---   
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
//---   ,      
   ObjectSetInteger(0,name,OBJPROP_CORNER,Corner);
//---  
   ObjectSetString(0,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(0,name,OBJPROP_FONT,FontName);
//---   
   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,FontSize);
//---  
   ObjectSetInteger(0,name,OBJPROP_COLOR,clr);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
void OnTimer()
  {
//       
   int delta=(int)(Time[0]+PeriodSeconds()-TimeCurrent());
// M    
   if(Corner==CORNER_RIGHT_UPPER || Corner==CORNER_RIGHT_LOWER)
     {
      PutLabel("TimeLabel1","   : "+TimeToString(Time[0]+Period()*60-TimeCurrent(),TIME_SECONDS),350,30,ClrDelta);
      PutLabel("TimeLabel2","  : "+TimeToString(Time[0]+Period()*60,TIME_SECONDS),320,55,ClrClose);
      PutLabel("TimeLabel3"," : "+TimeToString(TimeCurrent(),TIME_SECONDS),260,80,ClrTime);
     }
   else // M    
     {
      PutLabel("TimeLabel1","   : "+TimeToString(Time[0]+Period()*60-TimeCurrent(),TIME_SECONDS),20,30,ClrDelta);
      PutLabel("TimeLabel2","  : "+TimeToString(Time[0]+Period()*60,TIME_SECONDS),20,55,ClrClose);
      PutLabel("TimeLabel3"," : "+TimeToString(TimeCurrent(),TIME_SECONDS),20,80,ClrTime);
     }

   if(delta>SecondsSound) one=true;
//     AlertOn
   if(delta<=SecondsSound && one && AlertOn)
     {
      PlaySound("News.wav");
      Alert(" "+(string)SecondsSound+"     !");
      SendNotification(" "+(string)SecondsSound+"     !");
      SendMail(" "," "+(string)SecondsSound+"     !");
      one=false;
     }
  }
//+------------------------------------------------------------------+
